import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { SimpleGuard } from '@delon/auth';
import { environment } from '@env/environment';
// layout
import { LayoutDefaultComponent } from '../layout/default/default.component';
// import { LayoutFullScreenComponent } from '../layout/fullscreen/fullscreen.component';
import { LayoutPassportComponent } from '../layout/passport/passport.component';
// dashboard pages
// import { DashboardV1Component } from './dashboard/v1/v1.component';
// import { DashboardAnalysisComponent } from './dashboard/analysis/analysis.component';
// import { DashboardMonitorComponent } from './dashboard/monitor/monitor.component';
// import { DashboardWorkplaceComponent } from './dashboard/workplace/workplace.component';
// passport pages
import { UserLoginComponent } from './passport/login/login.component';
// import { UserRegisterComponent } from './passport/register/register.component';
// import { UserRegisterResultComponent } from './passport/register-result/register-result.component';
// single pages
// import { CallbackComponent } from './callback/callback.component';
// import { UserLockComponent } from './passport/lock/lock.component';
import { ProProfileAdvancedComponent } from './pro/profile/advanced/advanced.component';

const routes: Routes = [
  {
    path: '',
    component: LayoutDefaultComponent,
    canActivate: [SimpleGuard],
    canActivateChild: [SimpleGuard],
    children: [
      { path: '', redirectTo: 'detail', pathMatch: 'full' },
      { path: 'dashboard', redirectTo: 'detail', pathMatch: 'full' },
      { path: 'detail', component: ProProfileAdvancedComponent },
      // { path: '**', redirectTo: 'detail', pathMatch: 'full' }
    ]
  },
  // passport
  {
    path: 'passport',
    component: LayoutPassportComponent,
    children: [
      {
        path: 'login',
        component: UserLoginComponent,
        data: { title: '登录', titleI18n: 'app.login.login' },
      }
    ]
  }];
// { path: 'dashboard', redirectTo: 'dashboard/v1', pathMatch: 'full' },
// { path: 'dashboard/v1', component: DashboardV1Component },
// { path: 'dashboard/analysis', component: DashboardAnalysisComponent },
// { path: 'dashboard/monitor', component: DashboardMonitorComponent },
// { path: 'dashboard/workplace', component: DashboardWorkplaceComponent },
// {
//   path: 'widgets',
//     loadChildren: './widgets/widgets.module#WidgetsModule',
// },
// { path: 'style', loadChildren: './style/style.module#StyleModule' },
// { path: 'delon', loadChildren: './delon/delon.module#DelonModule' },
// { path: 'extras', loadChildren: './extras/extras.module#ExtrasModule' },
// { path: 'pro', loadChildren: './pro/pro.module#ProModule' },
// // Exception
// { path: 'exception', loadChildren: './exception/exception.module#ExceptionModule' },
// ,
//   // 全屏布局
//   {
//     path: 'data-v',
//     component: LayoutFullScreenComponent,
//     children: [
//       { path: '', loadChildren: './data-v/data-v.module#DataVModule' },
//     ],
//   },
//   // passport
//   {
//     path: 'passport',
//     component: LayoutPassportComponent,
//     children: [
//       {
//         path: 'login',
//         component: UserLoginComponent,
//         data: { title: '登录', titleI18n: 'app.login.login' },
//       },
//       {
//         path: 'register',
//         component: UserRegisterComponent,
//         data: { title: '注册', titleI18n: 'app.register.register' },
//       },
//       {
//         path: 'register-result',
//         component: UserRegisterResultComponent,
//         data: { title: '注册结果', titleI18n: 'app.register.register' },
//       },
//       {
//         path: 'lock',
//         component: UserLockComponent,
//         data: { title: '锁屏', titleI18n: 'app.lock' },
//       },
//     ],
//   },
//   // 单页不包裹Layout
//   { path: 'callback/:type', component: CallbackComponent },
//   { path: '**', redirectTo: 'exception/404' },
// ];

@NgModule({
  imports: [
    RouterModule.forRoot(
      routes, {
        useHash: environment.useHash,
        // NOTICE: If you use `reuse-tab` component and turn on keepingScroll you can set to `disabled`
        // Pls refer to https://ng-alain.com/components/reuse-tab
        scrollPositionRestoration: 'top',
      }
    )],
  exports: [RouterModule],
})
export class RouteRoutingModule {}
